/*** Copyright: OGIHARA Takeshi, March 2006 ***/

#import <Foundation/Foundation.h>
#import <stdio.h>

@interface A : NSObject
{
    int value;
}
- (NSString *)description;
- (void)setValue:(int)anInt;
@end

@interface B : A
@end

@interface C : B
@end

@interface D : A
@end

@implementation A
- (NSString *)description
{
    return [NSString stringWithFormat:@"%@ %p, super=%p, value=%d",
        NSStringFromClass([self class]),
        (void *)[self class], (void *)[self superclass], value];
}
- (void)setValue:(int)anInt { value = anInt; }
@end

@implementation B
- (void)setValue:(int)anInt {
    [super setValue:(anInt + 1)];
}
@end

@implementation C
- (void)setValue:(int)anInt {
    [super setValue:(anInt * 2 + 10)];
}
@end

@implementation D
- (void)setValue:(int)anInt {
    [super setValue:(anInt * 4 + 100)];
}
@end

int main(void)
{
    id w, x, y, z;
    Class aclass, bclass;
    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];

    aclass = [A class];
    bclass = [B class];
    // [B poseAsClass: aclass];        // (1)

    printf("Class A = %s %p\n",
        [NSStringFromClass(aclass) UTF8String], (void *)aclass);
    printf("Class B = %s %p\n",
        [NSStringFromClass(bclass) UTF8String], (void *)bclass);
    w = [[A alloc] init];
    [w setValue: 10];
    printf("%s\n", [[w description] UTF8String]);
    x = [[B alloc] init];
    [x setValue: 10];
    printf("%s\n", [[x description] UTF8String]);
    y = [[C alloc] init];
    [y setValue: 10];
    printf("%s\n", [[y description] UTF8String]);
    z = [[D alloc] init];                             // D
    [z setValue: 10];                                 // D
    printf("%s\n", [[z description] UTF8String]);     // D

    [pool release];
    return 0;
}
