/*** Copyright: OGIHARA Takeshi, March 2006 ***/

#import "TwoWayList.h"
#import <Foundation/NSException.h>
#import <Foundation/NSString.h>
#import <Foundation/NSKeyedArchiver.h>
#import <stdio.h>

static NSString *BLValue = @"BLValue";
static NSString *BLPrev = @"BLPrev";
static NSString *BLNext = @"BLNext";

@implementation TwoWayList

- (id)copyWithZone:(NSZone *)zone
{
    return NSCopyObject(self, 0, zone);
}

- (id)initWithIntValue:(int)val
{
    self = [super init];
    value = val;
    /* prev = next = nil; */
    return self;
}

- (void)dealloc
{
    [next release];
#ifdef DEBUG
    printf("dealloc: %d\n", value);
#endif
    [super dealloc];
}

- (void)addNewValue:(int)val
{
    if (value > val) {
        TwoWayList *tmp = [self copy];
        tmp->prev = self;
        if (next)
            next->prev = tmp;
        value = val;
        next = tmp;
    }else if (next)
        [next addNewValue:val];
    else {
        next = [[[self class] alloc] initWithIntValue:val];
        next->prev = self;
    }
}

- (id)next {
    NSAssert((next == nil || next->prev == self), @"Wrong Pointers");
    return next;
}
- (int)intValue { return value; }

- (void)encodeWithCoder:(NSCoder *)aCoder
{
    [aCoder encodeInt:value forKey:BLValue];
    [aCoder encodeObject:next forKey:BLNext];
    [aCoder encodeConditionalObject:prev forKey:BLPrev];
}

- (id)initWithCoder:(NSCoder *)aDecoder
{
    [super init];
    next = [[aDecoder decodeObjectForKey:BLNext] retain];
    prev = [aDecoder decodeObjectForKey:BLPrev];
    value = [aDecoder decodeIntForKey:BLValue];
    return self;
}

@end
