/*** Copyright: OGIHARA Takeshi, March 2006 ***/

#import <Foundation/Foundation.h>

static NSString *DifficultException = @"DifficultException";
static NSString *EasyException = @"EasyException";

static void callme(BOOL flag)
{
    @try {
        if (flag)
            [NSException raise:DifficultException format:@"Serious"];
        else
            @throw @"Illegal";
    }
    @catch (NSException *ex) {
        NSString *name = [ex name];
        NSLog(@"%@ caught in callme()\n", name);
        if (![name isEqualToString:EasyException])
            [ex raise];  // propagation
    }
    @finally {
        NSLog(@"callme finally\n");
    }
}

static void subfunc(BOOL flag)
{
    id obj = [[NSMutableData alloc] initWithCapacity:100];
    NSLog(@"subfunc start\n");
    @try {
        NSLog(@"callme start\n");
        callme(flag);
        NSLog(@"callme exit\n");
    }
    @finally {
        [obj release];
        NSLog(@"subfunc finally\n");
    }
    NSLog(@"subfunc exit\n");
}

int main(int argc, char *argv[])
{
    id pool = [[NSAutoreleasePool alloc] init];
    @try {
        subfunc(argc == 1);
    }
    @catch (id ex) {
        NSLog(@"%@ caught in main()\n", ex);
    }
    @finally {
        NSLog(@"main finally\n");
    }
    [pool release];
    return 0;
}
