/*** Copyright: OGIHARA Takeshi, March 2006 ***/

#import <Foundation/Foundation.h>
#import <stdlib.h>

NSString *MyException = @"MyException";

static void subfunc(int v)
{
    switch (v) {
    case 0:
        break;  // Do Nothing
    case 1:
        @throw @"REIGAI";
    case 2:
        @throw [NSNumber numberWithInt: v];
    case 3:
        @throw [NSMutableString stringWithString:@"Reigai"];
    case 4:
        @throw [NSDictionary dictionary];
    default:
        [NSException raise:MyException
                  format:@"Illegal operation with %d", v];
        break;
    }
}

int main(int argc, char *argv[])
{
    id pool = [[NSAutoreleasePool alloc] init];
    int val = (argc > 1) ? atoi(argv[1]) : 0;
 
    @try {
        subfunc(val);
        NSLog(@"function exit\n");
    }
    @catch (NSException *ex) {
        NSLog(@"Exception: %@, Reason: %@\n", [ex name], [ex reason]);
        @throw ex;
    }
    @catch (NSString *ex) {
        NSLog(@"String \"%@\" was caught\n", ex);
    }
    @catch (NSValue *ex) {
        NSLog(@"Value \"%@\" was caught\n", ex);
    }
    // @catch (NSNumber *ex) {
    //     NSLog(@"Number \"%@\" was caught\n", ex);
    // }
    @catch (id ex) {
        NSLog(@"Object \"%@\" was caught\n", ex);
        @throw;
    }
 
    NSLog(@"main exit\n");
    [pool release];
    return 0;
}
