/*** Copyright: OGIHARA Takeshi, March 2006 ***/

#import <Foundation/NSObject.h>
#import "types.h"

@class NSColor;

@protocol UroClient
- (NSColor *)color;
- (UroPoint)reset;
- (oneway void)start;
- (oneway void)stop;
@end

@interface UroPiece: NSObject <UroClient>
{
    UroPoint location;
    id controller;
    int lastDirection;
    NSColor *color;
    BOOL inAction;
}
+ (void)initialize;
+ (int)random:(int)range;
+ (void)setBoardWidth:(int)w height:(int)h;
+ (void)connectNewClient:(id)ports;
- (id)initWithController:(id)obj;
@end
