/*** Copyright: OGIHARA Takeshi, March 2006 ***/

#import "UroView.h"
#import <Cocoa/Cocoa.h>
#import "UroPiece.h"

@implementation UroView

- (id)initWithGrid:(int)grid width:(int)wid height:(int)hgt
{
    NSRect rect = NSMakeRect(0.0, 0.0, wid*grid, hgt*grid);
    [super initWithFrame:rect];
    gsize = grid, gwid = wid, ghgt = hgt; 
    return self;
}

- (void)setBoard:(id **)board { uBoard = board; }

- (void)drawRect:(NSRect)aRect
{
    int x, y, w;
    NSRect rect;
    int xmax, ymax;
    int xmin = (int)(aRect.origin.x) / gsize;
    int ymin = (int)(aRect.origin.y) / gsize;
    w = aRect.origin.x + aRect.size.width - 0.5;
    xmax = w / gsize;
    if (xmax > gwid) xmax = gwid;
    w = aRect.origin.y + aRect.size.height - 0.5;
    ymax = w / gsize;
    if (ymax > ghgt) ymax = ghgt;

    rect = NSMakeRect(xmin*gsize, ymin*gsize,
            (xmax-xmin+1)*gsize, (ymax-ymin+1)*gsize);
    [[NSColor whiteColor] set];
    [NSBezierPath fillRect:rect];
    rect.size = NSMakeSize(gsize-2, gsize-2);
    for (y = ymin; y <= ymax; y++) {
        rect.origin.y = y*gsize + 1.0;
        for (x = xmin; x <= xmax; x++) {
            id obj = uBoard[y][x];
            if (obj) {
                rect.origin.x = x*gsize + 1.0;
                [[obj color] set];
                [[NSBezierPath bezierPathWithOvalInRect:rect] fill];
            }
        }
    }
}

@end
