/*** Copyright: OGIHARA Takeshi, March 2006 ***/

#import "UroServer.h"
#import <Cocoa/Cocoa.h>
#import "UroView.h"
#import "UroRemotePiece.h"

@implementation UroServer

/* Local Method */
- (void)removeInvalidConnection:(NSNotification *)notification
{
    int n, i, x, y;
    NSRect rect;
    id obj = nil;
    id invalid = [notification object];
    n = [proxies count];
    for (i = 0; i < n; i++) {
        obj = [proxies objectAtIndex:i];
        if ([obj connectionForProxy] == invalid) {
            [obj retain];
            [proxies removeObjectAtIndex:i];
            break;
        }
    }
    if (obj == nil) return;
    for (y = 0; y < BHeight; y++)
        for (x = 0; x < BWidth; x++)
            if (uBoard[y][x] == obj) break;
    if (y >= BHeight) return;
    uBoard[y][x] = nil;
    [obj release];
    [invalid release];
    rect = NSMakeRect(x*GridSize, y*GridSize, GridSize, GridSize);
    [uView displayRect:rect];
}

/* Local Method */
- (void)setupServer
{
    id theConnection = [NSConnection defaultConnection];
    [theConnection setRootObject:self];
    if ([theConnection registerName: ServerName] == NO) {
        NSLog(@"Can't register server\n");
        return;
    }
    [[NSNotificationCenter defaultCenter] addObserver:self
        selector:@selector(removeInvalidConnection:)
        name:NSConnectionDidDieNotification object:nil];
}

- (BOOL)registerAsRemoteClient:(id)client
{
    if (!inAction)
        return NO;
    [client setProtocolForProxy:@protocol(UroRemoteClient)];
    [client setBoardWidth:BWidth height:BHeight];
    [proxies addObject:client];
    [self resetBoard:self];
    return YES;
}

/* Application Delegate Message */
- (void)applicationDidFinishLaunching:(NSNotification *)note
{
    [self setupServer];
    [super applicationDidFinishLaunching:note];
}

@end
