/*** Copyright: OGIHARA Takeshi, March 2006 ***/

#import <Foundation/Foundation.h>

#define MAXMEMBER  8

@interface Team : NSObject
{
    id   members[MAXMEMBER];
    int  count;
}
- (unsigned int)countOfFellows;
- (id)objectInFellowsAtIndex:(unsigned int)index;
@end

@implementation Team
- (void)addMember:(id)someone {
    if (count < MAXMEMBER)
        members[count++] = [someone retain];
}

- (unsigned int)countOfFellows {
     return count; 
}

- (id)objectInFellowsAtIndex:(unsigned int)index {
    return (index < count) ? members[index] : nil;
}
@end

int main(void)
{
    id pool = [[NSAutoreleasePool alloc] init];
    id aTeam = [[Team alloc] init];
    id obj;

    [aTeam addMember:@"Hiroshi"];
    [aTeam addMember:@"Mika"];
    obj = [aTeam valueForKey:@"fellows"];
    NSLog(@"obj=%@\n", NSStringFromClass([obj class]));
    NSLog(@"Fellows: %@\n", obj); 
    [pool release];
    return 0;
}
